#!/usr/bin/python
import sys
import vxi11
import time
import numpy as np

log_name = "dcl_10vdc_rndz_3458abc_advr6581t_dtr_hulk2_11rng_resl8_nplc20_soak3.dsv"

fluke = vxi11.Instrument("192.168.1.5", "gpib0,20") # Fluke 5720A, GPIB Address = 1
fluke.timeout = 75
#fluke.clear()
#fluke.write("*IDN?")
#print "Source detected = %s" % fluke.read()

dmm = vxi11.Instrument("192.168.1.2", "gpib0,3") # Keysight 3458A, GPIB Address = 1
dmm.timeout = 75
dmm.write("RESET")
dmm.clear()
#dmm.write("ID?")
#print "DUT1 detected = %s" % dmm.read()

dmm2 = vxi11.Instrument("192.168.1.2", "gpib0,11") # Keysight 3458A, GPIB Address = 1
dmm2.timeout = 75
dmm2.write("RESET")
dmm2.clear()
#dmm2.write("ID?")
#print "DUT2 detected = %s" % dmm2.read()

dmma = vxi11.Instrument("192.168.1.5", "gpib0,10") # Advantest 6581T
dmma.timeout = 75

dmmf = vxi11.Instrument("192.168.1.2", "gpib0,8") # D1281
dmmf.timeout = 75

dmma.write("*RST")
dmma.write(":STAT:PRES")
dmma.write(":INP:TERM FRON")
dmma.write(":SENS:VOLT:DC:RANG 10")
dmma.write(":SENS:VOLT:DC:NPLC 20")
dmma.write(":SENS:VOLT:DC:DIG MAX")
dmma.write(":SENS:VOLT:DC:PROT OFF")
dmma.write(":FORM:ELEM NONE")
dmma.clear()
#dmm2.write("ID?")
#print "DUT2 detected = %s" % dmm2.read()

dmm3 = vxi11.Instrument("192.168.1.2", "gpib0,2") # Fluke 8508A, GPIB Address = 1
dmm3.timeout = 75
dmm3.write("RESET")
dmm3.clear()
#print "DUT3 detected = %s" % dmm3.read()

fluke.write("STBY")
fluke.write("RANGELCK OFF")
fluke.write("OUT 10 V, 0 Hz")
fluke.write("RANGELCK ON")
fluke.write("STBY")
fluke.write("OUT 0.0 V, 0 Hz")
fluke.write("EXTGUARD OFF")
fluke.write("OPER")
fluke.write("RANGELCK ON")
time.sleep(2)
print "SRC configured"

dmm.write("BEEP")
dmm.write("END ALWAYS")
dmm.write("DCV 10")
dmm.write("NPLC 20")
dmm.write("NDIG 8")
dmm.write("TRIG AUTO")
dmm.write("MATH OFF")
print "DUT configured, starting ACAL"

dmm2.write("BEEP")
dmm2.write("END ALWAYS")
dmm2.write("DCV 10")
dmm2.write("NPLC 20")
dmm2.write("NDIG 8")
dmm2.write("TRIG AUTO")
dmm2.write("MATH OFF")
print "DUT2 configured, starting ACAL"

dmm3.write("BEEP")
dmm3.write("END ALWAYS")
dmm3.write("DCV 10")
dmm3.write("NPLC 20")
dmm3.write("NDIG 8")
dmm3.write("TRIG AUTO")
dmm3.write("MATH OFF")
print "DUT3 configured, starting ACAL"

#dmmf.write("*RST")
dmmf.write("TRG_SRCE EXT")
dmmf.write("DCV 10,FILT_OFF,RESL8,FAST_OFF")
#dmmf.write("GUARD REM") #Int for 8508
dmmf.write("AVG OFF")
dmmf.write("INPUT FRONT")
#dmm3.write("GATE FAST_OFF")
#dmm3.write("C LAST_RDG")
#dmm3.write("SUB_C OFF")
print "DUTF configured"

dmm.write("TARM SGL")
dmm.read()
dmm2.write("TARM SGL")
dmm2.read()
dmm3.write("TARM SGL")
dmm3.read()
dmm.write("MATH NULL")
dmm2.write("MATH NULL")
dmm3.write("MATH NULL")
dmm.write("TARM SGL") # Get reading
dmm.read()
dmm2.write("TARM SGL") # Get reading
dmm2.read()
dmm3.write("TARM SGL") # Get reading
dmm3.read()
print "DUTs is nulled to MFC zero"

with open(log_name, 'w') as dile:
    dile.write ("date;source;duta;dutb;dutc;dutd;dutx;dutf;sdev;sdev2;sdev3;sdev4;sdevx;sdevf;temp;temp2\r\n")
dile.close()

vcnt = 0 # temporary counter
print "Log into %s started" % log_name

for i in range(-6090,6090,47):
    median = 0.0
    sdev = 0.0
    array = []
    median2 = 0.0
    sdev2 = 0.0
    array2 = []
    median3 = 0.0
    sdev3 = 0.0
    array3 = []
    median4 = 0.0
    sdev4 = 0.0
    array4 = []
    medianx = 0.0
    sdevx = 0.0
    arrayx = []
    medianf = 0.0
    sdevf = 0.0
    arrayf = []
    set_value = (float(i) / 554.1401273885)
    fluke.write("OUT %.6f" % set_value)
    fluke.write("OPER")
    time.sleep(3)
    for ix in range (0,6): #take more samples
	dmm.write("TARM SGL")
	dmm2.write("TARM SGL")
	dmma.write("READ?")
	dmm3.write("TARM SGL")
	#dmm5.write("READ?") #*TRG;GET;RDG?")
	dmmf.write("*TRG;GET;RDG?")
	val = float(dmm.read()) # 3
	val2 = float(dmm2.read()) # 11
	val3 = float(dmma.read()) # adv
	val4 = float(dmm3.read()) # 2
	valx = float(dmmf.read())
	valf = 0#float(dmmf.read())
	#dmm4.write("READ?")
	array.extend([val])
	array2.extend([val2])
	array3.extend([val3])
	array4.extend([val4])
	arrayx.extend([valx])
	arrayf.extend([valf])
	if abs(set_value) >= 0.05:
	    print("\033[33;1mA %.8f, ppm %.4f \033[35;1mB %.8f, ppm %.4f \033[37;1mC %.8f, ppm %.4f \033[32;1mD %.8f, ppm %.4f\033[39;0m X%.8f, ppm %.4f | F %.4f\033[39;0m" % (val, ((val / set_value - 1) * 1e6), val2,((val2 /set_value - 1) * 1e6), val3,((val3 / set_value - 1) * 1e6),val4,((val4 / set_value - 1) * 1e6),valx,((valx / set_value - 1) * 1e6),((valf / set_value - 1) * 1e6) ))
    	if (abs(val) >= 9.9e36) or (abs(val2) >= 9.9e36):
	    print ("Smoke escaped, check connections")
	    fluke.write("OUT 0 V")
	    fluke.write("STBY")
	    quit()
    sdev = np.std(array[3:])
    median = np.median(array[3:])
    sdev2 = np.std(array2[3:])
    median2 = np.median(array2[3:])
    sdev3 = np.std(array3[3:])
    median3 = np.median(array3[3:])
    sdev4 = np.std(array4[3:])
    median4 = np.median(array4[3:])
    sdevx = np.std(arrayx[3:])
    medianx = np.median(arrayx[3:])
    sdevf = np.std(arrayf[3:])
    medianf = np.median(arrayf[3:])
    if abs(float(i) / 10) >= 0.0005:
	dev1 = ((median / set_value - 1) * 1e6)
	dev2 = ((median2 /set_value - 1) * 1e6)
	dev3 = ((median3 /set_value - 1) * 1e6)
	dev4 = ((median4 /set_value - 1) * 1e6)
	devx = ((medianx /set_value - 1) * 1e6)
	devf = ((medianf /set_value - 1) * 1e6)
	print("\033[32;1mSRC %.4f \033[33;1mA %.9f, sdev5 = %.3f uV, med5 = %.8f\033[35;1mB %.9f, sdev5 = %.3f uV, med5 = %.8f \033[34;1m Delta %.4f ppm \033[37;1mC %.9f, sdev5 = %.3f uV, med5 = %.8f\033[32;1m D %.9f, sdev5 = %.3f uV, med5 = %.8f\033[39;0m" % (set_value, val, sdev*1e6, median, val2,sdev2*1e6, median2, (dev1 - dev2),  val3,sdev3*1e6, median3, val4,sdev4*1e6, median4 ))
    temp = 24#float(dmm.read())
    temp2 = 24#float(dmm2.read())
    with open(log_name, 'a') as dile:
        dile.write (time.strftime("%m%d%Y-%H:%M:%S;") + ("%.9f;%.9f;%.9f;%.9f;%.9f;%.9f;%.9f;%.6g;%.6g;%.6g;%.6g;%.6g;%.6g;%.1f;%.1f\r\n" % (set_value, median, median2, median3, median4, medianx, medianf, sdev, sdev2, sdev3, sdev4, sdevx, sdevf, temp, temp2)))
    dile.close()

fluke.write("OUT 0 V")
fluke.write("STBY")
fluke.write("RANGELCK OFF")
dmm.write("RESET")
dmm2.write("RESET")
